/* 
 * File:   player.h
 * Author: Arthur Brandao
 *
 * Created on 28 novembre 2018
 */

#ifndef PLAYER_H
#define PLAYER_H

/* --- Include --- */
#include "constante.h"
#include "client.h"
#include "json.h"
#include "object.h"

/* --- Structure --- */
typedef struct{
    boolean ini; //Indique si initalisé
    /* Stats basique */
    int id; //Id du joueur <=> id du Client
    Client* cli; //Client pour communiquer avec le joueur
    int x; //Position X (gauche droite)
    int y; //Position Y (haut bas)
    int life; //Vie
    int maxLife; //Vie max
    int speed; //Vitesse de deplacement
    int classicBomb; //Nombre de bombe classique
    int mine; //Nombre de mine
    int remoteBomb; //Nombre de bombe télécommandée
    int maxBomb; //Nombre max de bombe simultané sur le terrain
    int nbBomb; //Nombre de bombe actuellement sur le terrain
    /* Bonus (Nombre de fois ou le bonus est pris). Les modifications sont toujours calculées par le serveur */
    int bombUp;
    int bombDown;
    int firePower;
    int scooter;
    int brokenLeg;
    int lifeMax;
    int lifeUp;
    int major;
    /* Les remote bomb posé par le joueur */
    Object* remote;
}Player;

/* --- Fonctions --- */
/**
 * Création d'un joueur
 * @param Player* La structure à initialiser
 * @param Client* La structure pour communiquer avec le joueur
 */
void create_player(Player*, Client*);

void describe_player(Player*, JsonEncoder*);

void describe_short_player(Player*, JsonEncoder*);

void add_player_object(Player*, int);

/**
 * Supprime un joueur
 * @param Player* La structure à supprimer
 */
void delete_player(Player*);

#endif /* PLAYER_H */

